=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, compression=xz" \
https://github.com/lemire/simdjson \
HEAD debian uupdate
