=== debian/changelog ===
simdjson (0.1.2-2) unstable; urgency=medium

  * Don't fail the build on SIGILL.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 17 May 2019 09:19:56 +0000

simdjson (0.1.2-1) unstable; urgency=medium

  * New upstream version 0.1.2
  * watch: follow the releases instead of git head
  * The -dev package should depend on libsimdjson0 (= ${binary:Version}).
  * Fix using-first-person-in-description.
  * Add symbols control file for libsimdjson0.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 17 May 2019 02:15:54 +0000
