=== tools/CMakeLists.txt ===
add_cpp_tool(json2json)
add_cpp_tool(jsonstats)
add_cpp_tool(minify)
