=== debian/changelog ===
simdjson (0.2.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:25:36 +0100

simdjson (0.2.1-1) unstable; urgency=medium

  * New upstream version 0.2.1
  * Refresh symbols list.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 08 Aug 2019 11:59:26 +0000
